using System.Linq;
using Microsoft.Samples.ServiceHosting.StorageClient;

namespace AzureTags.Core.Infrastructure
{
    public class ResourceDataContext : TableStorageDataServiceContext
    {
        internal const string UserTaggedResourceTableName = "UserTaggedResourceTable";

        internal ResourceDataContext()
            : this(StorageAccountInfo.GetDefaultTableStorageAccountFromConfiguration(true))
        {
        }

        internal ResourceDataContext(StorageAccountInfo storageAccountInfo)
            : base(storageAccountInfo)
        {
        }

        public IQueryable<UserTaggedResourceRow> UserTaggedResourceTable
        {
            get { return CreateQuery<UserTaggedResourceRow>(UserTaggedResourceTableName); }
        }

        #region Resource Implementation
        internal const string ResourceTableName = "ResourceTable";
        public IQueryable<ResourceRow> ResourceTable
        {
            get { return CreateQuery<ResourceRow>(ResourceTableName); }
        }

        #endregion
    }
}