using System;
using AzureTags.Core.Domain;
using Microsoft.Samples.ServiceHosting.StorageClient;

namespace AzureTags.Core.Infrastructure
{
    public class UserTaggedResourceRow : TableStorageEntity
    {
        public UserTaggedResourceRow()
        {
            PartitionKey = "ssmith";
            RowKey = String.Empty;
        }

        public UserTaggedResourceRow(UserTaggedResource resource)
        {
            PartitionKey = resource.UserId;
            RowKey = SecUtility.CombineToKey(resource.Resource.Hash, resource.Tag);
            Title = resource.Title;
            Description = resource.Description;
            Url = resource.Resource.Url;
            Hash = resource.Resource.Hash;
            Tag = resource.Tag;
            UserId = resource.UserId;
        }

        public string Title { get; set; }
        public string Description { get; set; }
        public string Url { get; set; }
        public string Hash { get; set; }
        public string Tag { get; set; }
        public string UserId { get; set; }
    }
}