﻿using System;
using System.Collections.Generic;
using AzureTags.Core.Domain;
using NUnit.Framework;

namespace AzureTags.Tests.UnitTests.Domain
{
    [TestFixture]
    public class UserTaggedResourceTester
    {
        private readonly Resource testResource = new Resource("http://SteveSmithBlog.com/");
        private readonly string testTitle = "test title";
        private readonly string testDescription = "test description";
        private readonly string testUserId = "ssmith";
        private readonly string testTag = "cool";

        [Test]
        public void CanCreateUserTaggedResourceAndReadProperties()
        {
            var testTags = new List<String> {"foo", "bar"};
            var myResource = new UserTaggedResource(testResource, testTag, testUserId, testTitle, testDescription);

            Assert.AreEqual(testResource, myResource.Resource);
            Assert.AreEqual(testUserId, myResource.UserId);
            Assert.AreEqual(testTitle, myResource.Title);
            Assert.AreEqual(testDescription, myResource.Description);
            Assert.AreEqual(testTag, myResource.Tag);
        }
    }
}