﻿using System;
using AzureTags.Core.Domain;
using NUnit.Framework;

namespace AzureTags.Tests.UnitTests.Domain
{
    [TestFixture]
    public class UserTester
    {
        private const string testEmail = "ssmith@example.com";
        private const string testOpenId = "testOpenId";
        private const string testPassword = "testPassword";
        private readonly Guid testUserId = Guid.Empty;
        private const string testUserName = "testUserName";

        [Test]
        public void CanCreateUserAndReadProperties()
        {
            var myUser = new User
                             {
                                 Email = testEmail,
                                 OpenId = testOpenId,
                                 Password = testPassword,
                                 Id = testUserId,
                                 UserName = testUserName
                             };

            Assert.AreEqual(testEmail, myUser.Email);
            Assert.AreEqual(testOpenId, myUser.OpenId);
            Assert.AreEqual(testPassword, myUser.Password);
            Assert.AreEqual(testUserId, myUser.Id);
            Assert.AreEqual(testUserName, myUser.UserName);
        }

        [Test]
        public void QueueMessageTester()
        {
            string testString = "Foo|http://foo.com|foo";
            string resultString = String.Format("{0}\n{1}\ntagged with {2}.", testString.Split('|'));
            Console.WriteLine(resultString);
        }
    }
}