﻿using System;
using AzureTags.Core.Domain;
using AzureTags.Core.Interfaces;
using AzureTags.Core.Services;
using AzureTags.Tests.UnitTests.Domain;
using Microsoft.Samples.ServiceHosting.StorageClient;
using NUnit.Framework;
using Rhino.Mocks;

namespace AzureTags.Tests.UnitTests.Services
{
    [TestFixture]
    public class PersistResourceServiceTester
    {
        private IResourceRepository mockResourceRepository;
        private MockRepository mocks;

        [SetUp]
        public void Setup()
        {
            mocks = new MockRepository();
            mockResourceRepository = mocks.StrictMock<IResourceRepository>();

        }

        [Test]
        public void CanCreatePersistResourceService()
        {
            var myService = new PersistResourceService(mockResourceRepository);
            Assert.IsNotNull(myService);
        }

        [Test]
        public void SaveNewResourceCallsRepositorySave()
        {
            var mockResourceRepository2 = MockRepository.GenerateMock<IResourceRepository>();

            mockResourceRepository2.Expect(x => x.SaveResource(Guid.Empty, Guid.Empty, null, null, null, null)).
                IgnoreArguments();

            var myService = new PersistResourceService(mockResourceRepository2);

            myService.SaveResource(Guid.Empty, Guid.Empty, null, null, null, null);

            mockResourceRepository2.VerifyAllExpectations();
        }

        [Test]
        [Ignore]
        public void CreateTables()
        {
            StorageAccountInfo account = StorageAccountInfo.GetDefaultTableStorageAccountFromConfiguration();
            TableStorage.CreateTablesFromModel(typeof(UserTaggedResource), account);
        }
    }

    public class UserTaggedResourceContext : TableStorageDataServiceContext
    {
        
    }

}