﻿using System;
using System.Collections.Generic;
using System.Net.Mail;
using AzureTags.Core.Domain;
using AzureTags.Core.Interfaces;
using AzureTags.Core.Services;
using NUnit.Framework;
using Rhino.Mocks;

namespace AzureTags.Tests.UnitTests.Services
{
    [TestFixture]
    public class RetrieveResourceServiceTester
    {
        private IResourceRepository mockResourceRepository;

        [SetUp]
        public void Setup()
        {
            mockResourceRepository = MockRepository.GenerateMock<IResourceRepository>();

        }
        [Test]
        public void CanCreateRetrieveResourceService()
        {
            var myService = new RetrieveResourceService(null);

            Assert.IsNotNull(myService);
        }

        //[Test]
        //public void ListResourcesReturnsEmptyList()
        //{
        //    var myRepository = new FakeResourceRepository();
        //    myRepository.Clear();
        //    var myService = new RetrieveResourceService(myRepository);

        //    Assert.AreEqual(0, myService.ListResources().Count);
        //}

        [Test]
        public void ListResourcesCallsRepositoryList()
        {
            mockResourceRepository.Stub(x=>x.ListResources()).Return(new List<Resource>());

            var myService = new RetrieveResourceService(mockResourceRepository);

            var myList = myService.ListResources();

            mockResourceRepository.AssertWasCalled(x => x.ListResources());

            Assert.IsNotNull(myList);
        }

        [Test]
        [Ignore]
        public void SendEmailTest()
        {
            string fromEmail = "ssmith@lakequincy.com";
            string toEmail = "ssmith.lists@gmail.com";
            var myMessage = new MailMessage(fromEmail, toEmail)
            {
                Subject = "Test from AzureTags"
            };
            myMessage.Body = String.Format("User {0} logged in.", "unittest");
            var server = new SmtpClient();
            server.Host = "localhost";
            server.Send(myMessage);

        }
    }
}