﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;
using AzureTags.Core.Domain;
using Microsoft.Samples.ServiceHosting.StorageClient;
using Microsoft.ServiceHosting.ServiceRuntime;
using AzureTags.Core.Infrastructure;

namespace RedDogMvcWeb.Controllers
{
    [HandleError]
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            // test storing a URL in table storage
            var myRepository = new TableStorageResourceRepository();

            var myResources = myRepository.ListUserTaggedResources(System.Web.HttpContext.Current.User.Identity.Name);

            return View(myResources);
        }

        public ActionResult About()
        {
            var myRepository = new TableStorageResourceRepository();

            int totalResourceCount = myRepository.TotalTags();

            ViewData["Title"] = String.Format("About AzureTags : {0} Items Tagged", totalResourceCount);

            return View();
        }
    }
}
