using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;
using System.Web.Security;
using AzureTags.Core.Domain;
using AzureTags.Core.Infrastructure;
using Microsoft.Samples.ServiceHosting.StorageClient;
using Microsoft.ServiceHosting.ServiceRuntime;

namespace AzureTags.WebRole.Controllers
{
    public class TagsController : Controller
    {
        //
        // GET: /Tag/Create

        [Authorize]
        public ActionResult Create()
        {
            return View();
        } 

        //
        // POST: /Tag/Create

        [Authorize]
        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Create(FormCollection collection)
        {
            var myRepository = new TableStorageResourceRepository();
            var resource = new UserTaggedResource();

            try
            {
                UpdateModel(resource);
                resource.UserId = System.Web.HttpContext.Current.User.Identity.Name;
                myRepository.SaveUserTaggedResource(resource);

                // send user email notifying them of newly saved resource
                var queue = QueueStorage.Create(StorageAccountInfo.GetDefaultQueueStorageAccountFromConfiguration()).GetQueue("loginqueue");
                MembershipUser currentUser = Membership.Provider.GetUser(User.Identity.Name, true /* userIsOnline */);
                string message = resource.Title + "|" + resource.Url + "|" + resource.Tag + "|" + currentUser.Email;
                var myMessage = new Message(message);
                RoleManager.WriteToLog("Information", queue.QueueUri.ToString());
                queue.PutMessage(myMessage);
                RoleManager.WriteToLog("Information", String.Format("Message added to queue: {0}", message));
                RoleManager.WriteToLog("Information", string.Format("Queue Count Immediately Following Put: '{0}'", queue.ApproximateCount()));

                return RedirectToAction("Index", "Home");
            }
            catch
            {
                throw;
                return View();
            }
        }
    }
}
