﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using Microsoft.Samples.ServiceHosting.StorageClient;
using AzureTags.Core.Infrastructure;

namespace RedDogMvcWeb
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    public class MvcApplication : System.Web.HttpApplication
    {
        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute("Login", "login", new {controller = "Account", action = "Login"});

            routes.MapRoute(
                "Default",                                              // Route name
                "{controller}/{action}/{id}",                           // URL with parameters
                new { controller = "Home", action = "Index", id = "" }  // Parameter defaults
            );

        }

        protected void Application_Start()
        {
            RegisterRoutes(RouteTable.Routes);
        }

        protected void Application_BeginRequest()
        {
            //BlobStorage.Create(StorageAccountInfo.GetDefaultBlobStorageAccountFromConfiguration()).GetBlobContainer("images").CreateContainer(null, ContainerAccessControl.Public);
            TableStorage.CreateTablesFromModel(typeof(ResourceDataContext));
            //QueueStorage.Create(StorageAccountInfo.GetDefaultQueueStorageAccountFromConfiguration()).GetQueue("loginqueue").CreateQueue();
        }

    }
}