﻿using System.Web.Profile;
using System.Web.Security;

public class UserProfile : ProfileBase
{
    [SettingsAllowAnonymous(false)]
    public string Country
    {
        get { return base["Country"] as string; }
        set { base["Country"] = value; }
    }

    [SettingsAllowAnonymous(false)]
    public string Gender
    {
        get { return base["Gender"] as string; }
        set { base["Gender"] = value; }
    }

    [SettingsAllowAnonymous(false)]
    public int Age
    {
        get { return (int)(base["Age"]); }
        set { base["Age"] = value; }
    }

    public static UserProfile GetUserProfile(string username)
    {
        return Create(username) as UserProfile;
    }

    public static UserProfile GetUserProfile()
    {
        return Create(Membership.GetUser().UserName) as UserProfile;
    }
}