﻿using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Text.RegularExpressions;
using System.Web.Caching;

namespace ASPNETTipsAndTricks
{
    public partial class Caching2 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, System.EventArgs e)
        {
            BindGridView();
        }

        private void BindGridView()
        {
            CategoriesGridView.DataSource = GetCategories();
            CategoriesGridView.DataBind();
        }

        private DataTable GetCategories()
        {
            string cacheKey = "Categories";
            DataTable categoriesTable = Cache[cacheKey] as DataTable;

            if (categoriesTable == null)
            {
                Trace.Warn("Not in cache");

                SqlConnection conn =
                    new SqlConnection(ConfigurationManager.ConnectionStrings["NorthwindConnectionString"].ConnectionString);
                SqlDataAdapter cmd = new SqlDataAdapter("SELECT * FROM dbo.Categories", conn);

                categoriesTable = new DataTable("Categories");
                cmd.Fill(categoriesTable);

                SqlCacheDependency myDependency = new SqlCacheDependency("NorthwindDB", "dbo.Categories");

                Cache.Insert(cacheKey, categoriesTable, myDependency,null, null, CacheItemPriority.NotRemovable,);
                // note - don't bother caching LINQ expressions; only the results
            }
            else
            {
                Trace.Warn("In cache");
            }

            return categoriesTable;

        }

    }
}
