﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Data.SqlClient;
using System.Data;

namespace ASPNETTipsAndTricksTests
{
    /// <summary>
    /// Summary description for UsingAndExceptions
    /// </summary>
    [TestClass]
    public class UsingAndExceptions
    {
        readonly string connectionString = "";
        public UsingAndExceptions()
        {
            connectionString = ConfigurationManager.ConnectionStrings["NorthwindConnectionString"].ConnectionString;
            //connectionString = "Data Source=Balrog;Initial Catalog=Northwind; uid=sa;pwd=nevets;";
        }
        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void NoUsing()
        {
            //System.Threading.Thread.Sleep(100);
            try
            {
                string query = "SELECT * FROM Categories";
                SqlConnection myConnection = new SqlConnection(connectionString);
                SqlCommand myCommand = new SqlCommand(query, myConnection);
                try
                {


                    myConnection.Open();
                    SqlDataReader myReader = myCommand.ExecuteReader();
                    try
                    {

                        while (myReader.Read())
                        {
                            Console.WriteLine(myReader[1]);

                            // sometimes, blows up
                            if (new System.Random().Next(2) == 0)
                            {
                                throw new Exception();
                            }
                        }
                    }
                    finally
                    {
                        myReader.Dispose();
                    }
                }
                finally
                {
                    myConnection.Dispose();
                }
            }
            catch
            {
                // gulp
            }
        }
        [TestMethod]
        public void WithUsing()
        {
            //System.Threading.Thread.Sleep(100);
            try
            {
                string query = "SELECT * FROM Categories";
                using (SqlConnection myConnection = new SqlConnection(connectionString))
                using (SqlCommand myCommand = new SqlCommand(query, myConnection))
                {

                    myConnection.Open();
                    using (SqlDataReader myReader = myCommand.ExecuteReader(CommandBehavior.CloseConnection))
                    {
                        while (myReader.Read())
                        {
                            Console.WriteLine(myReader[1]);

                            // sometimes, blows up
                            if (new System.Random().Next(2) == 0)
                            {
                                throw new Exception();
                            }
                        }
                        myReader.Close();
                    }
                    myConnection.Close();
                }
            }
            catch
            {
                // gulp
            }
        }
    }
}
